---
title: 'CSS grids, logical values, and writing modes'
slug: 'Web/CSS/CSS_Grid_Layout/CSS_Grid,_Logical_Values_and_Writing_Modes'
tags:
  - CSS
  - CSS Grids
  - Guide
---
<p class="summary">In these guides, I have already touched on an important feature of grid layout: the support for different writing modes that is built into the specification. <span class="seoSummary">For this guide, we will look at this feature of grid and other modern layout methods, learning a little about writing modes and logical vs. physical properties as we do so.</span></p>

<h2 id="Logical_and_physical_properties_and_values">Logical and physical properties and values</h2>

<p>CSS is full of <strong>physical</strong> positioning keywords – left and right, top and bottom. If we position an item using absolute positioning, we use these physical keywords as offset values to push the item around. In the code snippet below, the item is placed 20 pixels from the top, and 30 pixels from the left of the container:</p>

<pre class="brush:css notranslate">.container {
  position: relative;
}
.item {
  position: absolute;
  top: 20px;
  left: 30px;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="container"&gt;
  &lt;div class="item"&gt;Item&lt;/div&gt;
&lt;/div&gt;
</pre>

<p>Another place you might see physical keywords in use, is when using <code>text-align: right</code> to align text to the right. There are also physical <strong>properties</strong> in CSS. We add margins, padding, and borders using these physical properties of {{cssxref("margin-left")}}, {{cssxref("padding-left")}}, and so on.</p>

<p>We call these keywords and properties <em>physical</em> because they relate to the screen you are looking at. Left is always left, no matter what direction your text is running.</p>

<p>This can become an issue when developing a site that has to work in multiple languages, including languages that have text starting on the right, rather than the left. Browsers are pretty good at dealing with text direction, and you don’t even need to be working in a {{glossary("rtl")}} language to take a look. In the example below, I have two paragraphs. One has no {{cssxref("text-align")}} property set, the second has <code>text-align</code> set to left. I have added <code>dir="rtl"</code> to the <code>html</code> element, which switches the writing mode from the default for an English language document of <code>ltr</code>. You can see that the first paragraph remains left to right, due to the <code>text-align</code> value being <code>left</code> . The second however, switches direction and the text runs from right to left .</p>

<p><img alt="A simple example of text direction." src="https://mdn.mozillademos.org/files/14733/8_direction_simple_example.png" style="height: 354px; width: 1136px;"></p>

<p>This is a very simple example of the problem with physical values and properties being used in CSS. They prevent the browser being able to do the work to switch writing mode, as they make the assumption that the text is flowing left to right and top to bottom.</p>

<h3 id="Logical_properties_and_values">Logical properties and values</h3>

<p>Logical properties and values do not make an assumption about text direction. Which is why in Grid Layout we use the keyword <code>start</code> when aligning something to the start of the container. For me, working in English, <code>start</code> may well be on the left, however it doesn’t have to be, and the word <code>start</code> infers no physical location.</p>

<h2 id="Block_and_Inline">Block and Inline</h2>

<p>Once we begin dealing with logical, rather than physical properties, we stop seeing the world as left to right, and top to bottom. We need a new reference point, and this is where understanding the <em>block</em> and <em>inline</em> axes, that we met previously in the guide to <em>alignment</em>, becomes very useful. If you can start to see layout in terms of block and inline, the way things work in grid start to make a lot more sense.</p>

<p><img alt="An image showing the default direction of the Block and Inline Axes." src="https://mdn.mozillademos.org/files/14735/8-horizontal-tb.png" style="height: 256px; width: 500px;"></p>

<h2 id="CSS_writing_modes">CSS writing modes</h2>

<p>I’m going to introduce another specification here, that I will be using in my examples: the CSS Writing Modes specification. This spec details how we can use these different writing modes in CSS, not just for the support of languages that have a different writing mode to English, but also for creative purposes. I’ll be using the {{cssxref("writing-mode")}} property to make changes to the writing mode applied to our grid, in order to demonstrate how the logical values work. If you want to dig into writing modes further, however, then I would recommend that you read Jen Simmons excellent article on <a href="https://24ways.org/2016/css-writing-modes/">CSS Writing Modes</a>. This goes into more depth on that specification than we will touch upon here.</p>

<h3 id="writing-mode">writing-mode</h3>

<p>Writing Modes are more than just left to right and right to left text, and the <code>writing-mode</code> property helps us display text running in other directions. The {{cssxref("writing-mode")}} property can have values of:</p>

<ul>
 <li><code>horizontal-tb</code></li>
 <li><code>vertical-rl</code></li>
 <li><code>vertical-lr</code></li>
 <li><code>sideways-rl</code></li>
 <li><code>sideways-lr</code></li>
</ul>

<p>The value <code>horizontal-tb</code> is the default for text on the web. It is the direction in which you are reading this guide. The other properties will change the way that text flows in our document, matching the different writing modes found around the world. Again, for full details of these see <a href="https://24ways.org/2016/css-writing-modes/">Jen’s article</a>. As a simple example, I have two paragraphs below. The first uses the default <code>horizontal-tb</code>, and the second uses <code>vertical-rl</code>. In the mode text still runs left to right, however the direction of the text is vertical - inline text now runs down the page, from top to bottom.</p>

<div id="writing_1">
<div class="hidden">
<pre class="brush: css notranslate">.wrapper &gt; p {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    margin: 1em;
    color: #d9480f;
    max-width: 300px;
}
</pre>
</div>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
   &lt;p style="writing-mode: horizontal-tb"&gt;I have writing mode set to the default &lt;code&gt;horizontal-tb&lt;/code&gt;&lt;/p&gt;
  &lt;p style="writing-mode: vertical-rl"&gt;I have writing mode set to &lt;code&gt;vertical-rl&lt;/code&gt;&lt;/p&gt;
&lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('writing_1', '500', '420') }}</p>
</div>

<h2 id="Writing_modes_in_grid_layouts">Writing modes in grid layouts</h2>

<p>If we now take a look at a grid layout example, we can see how changing the writing mode means changing our idea of where the Block and Inline Axis are.</p>

<p>The grid in my next example has three columns and two row tracks. This means there are three tracks running down the block axis. In default writing mode, grid auto-places items starting at the top left, moving along to the right, filling up the three cells on the inline axis. It then moves onto the next line, creating a new Row track, and fills in more items:</p>

<div id="writing_2">
<div class="hidden">
<pre class="brush: css notranslate">* {box-sizing: border-box;}

.wrapper {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
}

.wrapper &gt; div {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    color: #d9480f;
}
</pre>
</div>

<pre class="brush: css notranslate">.wrapper {
  display: grid;
  grid-template-columns: repeat(3, 100px);
  grid-template-rows: repeat(2, 100px);
gap: 10px;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
  &lt;div class="item1"&gt;Item 1&lt;/div&gt;
  &lt;div class="item2"&gt;Item 2&lt;/div&gt;
  &lt;div class="item3"&gt;Item 3&lt;/div&gt;
  &lt;div class="item4"&gt;Item 4&lt;/div&gt;
  &lt;div class="item5"&gt;Item 5&lt;/div&gt;
&lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('writing_2', '500', '330') }}</p>
</div>

<p>If we add <code>writing-mode: vertical-lr</code> to the grid container, we can see that the block and inline Axis are now running in a different direction. The block or <em>column</em> axis now runs across the page from left to right, Inline runs down the page, creating rows from top to bottom.</p>

<div id="writing_3">
<div class="hidden">
<pre class="brush: css notranslate">* {box-sizing: border-box;}

.wrapper {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
}

.wrapper &gt; div {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    color: #d9480f;
}
</pre>
</div>

<pre class="brush: css notranslate">.wrapper {
  writing-mode: vertical-lr;
  display: grid;
  grid-template-columns: repeat(3, 100px);
  grid-template-rows: repeat(2, 100px);
  gap: 10px;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
  &lt;div class="item1"&gt;Item 1&lt;/div&gt;
  &lt;div class="item2"&gt;Item 2&lt;/div&gt;
  &lt;div class="item3"&gt;Item 3&lt;/div&gt;
  &lt;div class="item4"&gt;Item 4&lt;/div&gt;
  &lt;div class="item5"&gt;Item 5&lt;/div&gt;
&lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('writing_3', '500', '330') }}</p>
</div>

<p><img alt="A image showing the direction of Block and Inline when writing-mode is vertical-lr" src="https://mdn.mozillademos.org/files/14737/8-vertical-lr.png" style="height: 360px; width: 257px;"></p>

<h2 id="Logical_values_for_alignment">Logical values for alignment</h2>

<p>With the block and inline axis able to change direction, the logical values for the alignment properties start to make more sense.</p>

<p>In this next example, I am using alignment to align items inside a grid that is set to <code>writing-mode: vertical-lr</code>. The <code>start</code> and <code>end</code> properties work in exactly the same way that they do in the default writing mode, and remain logical in a way that using left and right, top and bottom to align items would not do. This occurs once we've flipped the grid onto the side, like this:</p>

<div id="writing_4">
<div class="hidden">
<pre class="brush: css notranslate">* {box-sizing: border-box;}

.wrapper {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
}

.wrapper &gt; div {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    color: #d9480f;
}
</pre>
</div>

<pre class="brush: css notranslate">.wrapper {
  writing-mode: vertical-lr;
  display: grid;
  grid-template-columns: repeat(3, 1fr);
  grid-template-rows: repeat(3, 100px);
  gap: 10px;
}

.item1 {
    grid-column: 1 / 4;
    align-self: start;
}

.item2 {
    grid-column: 1 / 3;
    grid-row: 2 / 4;
    align-self: start;
}

.item3 {
    grid-column: 3;
    grid-row: 2 / 4;
    align-self: end;
    justify-self: end;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
  &lt;div class="item1"&gt;Item 1&lt;/div&gt;
  &lt;div class="item2"&gt;Item 2&lt;/div&gt;
  &lt;div class="item3"&gt;Item 3&lt;/div&gt;
&lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('writing_4', '500', '330') }}</p>
</div>

<p>If you want to see how these work, with a right to left as well as top to bottom writing mode, switch <code>vertical-lr</code> to <code>vertical-rl</code>, which is a vertical writing mode running from right to left.</p>

<h2 id="Auto-placement_and_Writing_Modes">Auto-placement and Writing Modes</h2>

<p>In the example already shown, you can see how writing mode changes the direction in which items place themselves onto the grid. Items will, by default, place themselves along the Inline axis then move onto a new row. However, that inline axis may not always run from left to right.</p>

<h2 id="Line-based_placement_and_Writing_Modes">Line-based placement and Writing Modes</h2>

<p>The key thing to remember when placing items by line number, is that line 1 is the start line, no matter which writing mode you are in. Line -1 is the end line, no matter which writing mode you are in.</p>

<p>In this next example, I have a grid which is in the default <code>ltr</code> direction. I have positioned three items using line-based placement.</p>

<ul>
 <li>Item 1 starts at column line 1, spanning one track.</li>
 <li>Item 2 starts at column line -1, spanning to -3.</li>
 <li>Item 3 starts at column line 1, spanning to column line 3.</li>
</ul>

<div id="writing_5">
<div class="hidden">
<pre class="brush: css notranslate">* {box-sizing: border-box;}

.wrapper {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
}

.wrapper &gt; div {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    color: #d9480f;
}
</pre>
</div>

<pre class="brush: css notranslate">.wrapper {
  display: grid;
  grid-template-columns: repeat(3, 1fr);
  grid-template-rows: repeat(2, 100px);
  gap: 10px;
}
.item1 {
    grid-column: 1 ;
}
.item2 {
    grid-column: -1 / -3;
}
.item3 {
    grid-column: 1 / 3;
    grid-row: 2;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
        &lt;div class="item1"&gt;Item 1&lt;/div&gt;
        &lt;div class="item2"&gt;Item 2&lt;/div&gt;
        &lt;div class="item3"&gt;Item 3&lt;/div&gt;
    &lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('writing_5', '500', '330') }}</p>
</div>

<p>If I now add the {{cssxref("direction")}} property with a value of <code>rtl</code> to the grid container, line 1 becomes the right hand side of the grid, and line -1 on the left.</p>

<div id="writing_6">
<div class="hidden">
<pre class="brush: css notranslate">* {box-sizing: border-box;}

.wrapper {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
}

.wrapper &gt; div {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    color: #d9480f;
}
</pre>
</div>

<pre class="brush: css notranslate">.wrapper {
  direction: rtl;
  display: grid;
  grid-template-columns: repeat(3, 1fr);
  grid-template-rows: repeat(2, 100px);
  gap: 10px;
}
.item1 {
    grid-column: 1 ;
}
.item2 {
    grid-column: -1 / -3;
}
.item3 {
    grid-column: 1 / 3;
    grid-row: 2;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
        &lt;div class="item1"&gt;Item 1&lt;/div&gt;
        &lt;div class="item2"&gt;Item 2&lt;/div&gt;
        &lt;div class="item3"&gt;Item 3&lt;/div&gt;
    &lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('writing_6', '500', '330') }}</p>
</div>

<p>What this demonstrates, is that if you are switching the direction of your text, either for entire pages or for parts of pages, and are using lines: you may want to name your lines, if you do not want the layout to completely switch direction. For some things, for example, where a grid contains text content, this switching may be exactly what you want. For other usage it may not.</p>

<h3 id="The_strange_order_of_values_in_the_grid-area_property">The strange order of values in the <code>grid-area</code> property</h3>

<p>You can use the {{cssxref("grid-area")}} property to specify all four lines of a grid area as one value. When people first encounter this, they are often surprised that the values do not follow the same order as the shorthand for margin – which runs clockwise: top, right, bottom, left.</p>

<p>The order of <code>grid-area</code> values is:</p>

<ul>
 <li><code>grid-row-start</code></li>
 <li><code>grid-column-start</code></li>
 <li><code>grid-row-end</code></li>
 <li><code>grid-column-end</code></li>
</ul>

<p>Which for English, in left-to-right means the order is:</p>

<ul>
 <li><code>top</code></li>
 <li><code>left</code></li>
 <li><code>bottom</code></li>
 <li><code>right</code></li>
</ul>

<p>This is anti-clockwise! So the reverse of what we do for margins and padding. Once you realize that <code>grid-area</code> sees the world as "block and inline", you can remember that we are setting the two starts, then the two ends. It becomes much more logical once you know!</p>

<h2 id="Mixed_writing_modes_and_grid_layout">Mixed writing modes and grid layout</h2>

<p>In addition to displaying documents, using the correct writing mode for the language, writing modes can be used creatively within documents that are otherwise <code>ltr</code>. In this next example I have a grid layout with a set of links down one side. I’ve used writing modes to turn these on their side in the column track:</p>

<div id="writing_7">
<pre class="brush: css notranslate">.wrapper {
    display: grid;
    grid-gap: 20px;
    grid-template-columns: 1fr auto;
    font: 1em Helvetica, Arial, sans-serif;
}
.wrapper nav {
    writing-mode: vertical-lr;
}
.wrapper ul {
    list-style: none;
    margin: 0;
    padding: 1em;
    display: flex;
    justify-content: space-between;
}
.wrapper a {
    text-decoration: none;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
        &lt;div class="content"&gt;
            &lt;p&gt;Turnip greens yarrow ricebean rutabaga endive cauliflower sea lettuce kohlrabi amaranth water spinach avocado daikon napa cabbage asparagus winter purslane kale. Celery potato scallion desert raisin horseradish spinach carrot soko. Lotus root water spinach fennel kombu maize bamboo shoot green bean swiss chard seakale pumpkin onion chickpea gram corn pea. Brussels sprout coriander water chestnut gourd swiss chard wakame kohlrabi beetroot carrot watercress. Corn amaranth salsify bunya nuts nori azuki bean chickweed potato bell pepper artichoke.&lt;/p&gt;
            &lt;p&gt;Nori grape silver beet broccoli kombu beet greens fava bean potato quandong celery. Bunya nuts black-eyed pea prairie turnip leek lentil turnip greens parsnip. Sea lettuce lettuce water chestnut eggplant winter purslane fennel azuki bean earthnut pea sierra leone bologi leek soko chicory celtuce parsley jícama salsify.&lt;/p&gt;
        &lt;/div&gt;
        &lt;nav&gt;
            &lt;ul&gt;
                &lt;li&gt;&lt;a href=""&gt;Link 1&lt;/a&gt;&lt;/li&gt;
                &lt;li&gt;&lt;a href=""&gt;Link 2&lt;/a&gt;&lt;/li&gt;
                &lt;li&gt;&lt;a href=""&gt;Link 3&lt;/a&gt;&lt;/li&gt;
            &lt;/ul&gt;
        &lt;/nav&gt;
    &lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('writing_7', '500', '330') }}</p>
</div>

<h2 id="Physical_values_and_grid_layout">Physical values and grid layout</h2>

<p>We encounter physical properties frequently when building websites, and while the grid placement and alignment properties and values respect writing modes, there are things you may want to do with Grid that force you to use physical properties and values. In the guide to <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Box_Alignment_in_CSS_Grid_Layout">Box alignment and grids</a>, I demonstrated how auto margins work in a grid area. Using an auto margin to push one item away from the others is a common flexbox trick too, however this also ties the layout to the physical space.</p>

<p>If you use absolute positioning within a grid area, then you will again be using physical offsets to push the item around inside the grid area. The key thing is to be aware of, is the tension between physical and logical properties and values. For example, be aware that you may need to make changes to your CSS to cope with a switch from <code>ltr</code> to <code>rtl</code>.</p>

<h3 id="Logical_properties_for_everything!">Logical properties for everything!</h3>

<p>Our new layout methods give us the ability to use these logical values to place items, however, as soon as we start to combine them with the physical properties used for margins and padding, we need to remember that those physical properties will not change according to writing mode.</p>

<p>The <a href="https://drafts.csswg.org/css-logical-props/">CSS Logical Properties specification</a> means that you can use the <a href="/en-US/docs/Web/CSS/CSS_Logical_Properties">logical equivalents</a> for properties, such as {{cssxref("margin-left")}} and {{cssxref("margin-right")}}, in your CSS. These properties and values have good support in modern browsers. Your understanding of block and inline through grid will help you to understand how to use these too.</p>

<section class="Quick_links" id="Quick_Links">
<ol>
 <li><a href="/en-US/docs/Web/CSS"><strong>CSS</strong></a></li>
 <li><a href="/en-US/docs/Web/CSS/Reference"><strong>CSS Reference</strong></a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid Layout</a></li>
 <li data-default-state="open"><a href="#"><strong>Guides</strong></a>
  <ol>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Basic_Concepts_of_Grid_Layout">Basics concepts of grid layout</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Relationship_of_Grid_Layout">Relationship to other layout methods</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Line-based_Placement_with_CSS_Grid">Line-based placement</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Grid_Template_Areas">Grid template areas</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Layout_using_Named_Grid_Lines">Layout using named grid lines</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Auto-placement_in_CSS_Grid_Layout">Auto-placement in grid layout</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Box_Alignment_in_CSS_Grid_Layout">Box alignment in grid layout</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid,_Logical_Values_and_Writing_Modes">Grids, logical values and writing modes</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_Layout_and_Accessibility">CSS Grid Layout and Accessibility</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_and_Progressive_Enhancement">CSS Grid Layout and Progressive Enhancement</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Realizing_common_layouts_using_CSS_Grid_Layout">Realizing common layouts using grids</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Subgrid">Subgrid</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Masonry_Layout">Masonry layout</a></li>
  </ol>
 </li>
 <li data-default-state="open"><a href="#"><strong>Properties</strong></a>
  <ol>
   <li><code><a href="/en-US/docs/Web/CSS/align-tracks">align-tracks</a></code>{{Experimental_Inline}}</li>
   <li><code><a href="/en-US/docs/Web/CSS/column-gap">column-gap</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/gap">gap</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid">grid</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-area">grid-area</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-auto-columns">grid-auto-columns</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-auto-flow">grid-auto-flow</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-auto-rows">grid-auto-rows</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-column">grid-column</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-column-end">grid-column-end</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-column-start">grid-column-start</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-row">grid-row</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-row-end">grid-row-end</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-row-start">grid-row-start</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-template">grid-template</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-template-areas">grid-template-areas</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-template-columns">grid-template-columns</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-template-rows">grid-template-rows</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/justify-tracks">justify-tracks</a></code>{{Experimental_Inline}}</li>
   <li><code><a href="/en-US/docs/Web/CSS/masonry-auto-flow">masonry-auto-flow</a></code>{{Experimental_Inline}}</li>
   <li><code><a href="/en-US/docs/Web/CSS/row-gap">row-gap</a></code></li>
   <li></li>
  </ol>
 </li>
 <li data-default-state="open"><a href="#"><strong>Glossary</strong></a>
  <ol>
   <li><a href="/en-US/docs/Glossary/Grid">Grid</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_lines">Grid lines</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_tracks">Grid tracks</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_cell">Grid cell</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_areas">Grid areas</a></li>
   <li><a href="/en-US/docs/Glossary/Gutters">Gutters</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_Axis">Grid Axis</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_rows">Grid row</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_column">Grid column</a></li>
  </ol>
 </li>
</ol>
</section>
